//CustomToolbar.h : Declaration of the CustomToolbar

#pragma once

#include <atlwin.h>
#include <commctrl.h>
#include "Resource.h"
#include "TbEdit.h"

class CToolBand;

/**
 *	A wrapper around the toolbar control.
 */
class CCustomToolbar : public CWindowImpl<CCustomToolbar, CToolBarCtrl>
{
// External Interface
public:

	CCustomToolbar();
	virtual ~CCustomToolbar();

	BEGIN_MSG_MAP(CCustomToolbar)
		CHAIN_MSG_MAP_MEMBER(m_editWnd)
		MESSAGE_HANDLER( WM_CREATE, OnCreate )
		MESSAGE_HANDLER( WM_SIZE, OnSize)
		MESSAGE_HANDLER( WM_COMMAND, OnCommand )
		MESSAGE_HANDLER( WM_DOSEARCH, OnDoSearch )
	END_MSG_MAP()

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDoSearch(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	inline	CTbEdit* GetEditPtr() {return &m_editWnd;}
	void	SetBrowser(IWebBrowser2* pBrowser);
	void	SetFocusControl();

// Internal Routines
private:
	void	doSearch();
	void	makeRequestString(LPCTSTR szIn, _bstr_t& bstrOut );

// Data
private:

	CTbEdit			m_editWnd;
	IWebBrowser2*	m_pBrowser;
};
