// TbEdit.cpp : Implementation of CTbEdit

#include "stdafx.h"
#include "TbEdit.h"
#include "ToolBand.h"

/////////////////////////////////////////////////////////////////////////////
// CTbEdit

CTbEdit::CTbEdit()
: m_pBand(NULL)
{
}

CTbEdit::~CTbEdit()
{
}
/**
 *   WM_ handler
 */
LRESULT CTbEdit::OnSetFocus(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	//Notify host that our band has the focus so TranslateAcceleratorIO 
	//messages are directed towards our band.
	if ( m_pBand ) {
		m_pBand->FocusChange(TRUE);
	}
	return 0;
}

/**
 *	
 */
STDMETHODIMP CTbEdit::TranslateAcceleratorIO(LPMSG lpMsg)
{
	int nVirtKey = (int)(lpMsg->wParam);
	if (VK_RETURN == nVirtKey)
	{
		// remove system beep on enter key by setting key code to 0
		lpMsg->wParam = 0;
		::PostMessage(GetParent(), WM_DOSEARCH, 0, 0);
		return S_OK;
	}
	else if (WM_KEYDOWN == lpMsg->message && nVirtKey == VK_TAB )
	{
		if (m_pBand) {
			m_pBand->FocusChange(FALSE);
		}
		return S_FALSE;
	}

	TranslateMessage(lpMsg);
	DispatchMessage(lpMsg);
	return S_OK;
}
