// BandTool.h : Declaration of the CToolBand

#pragma once
#include "resource.h"       // main symbols

#include "tb4ie.h"

// This is needed for IDeskBand
#include <shlobj.h>

#include "CustomToolbar.h"
#include "ReflectionWnd.h"

// CToolBand

class ATL_NO_VTABLE CToolBand : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CToolBand, &CLSID_CoToolBand>,
	public IObjectWithSiteImpl<CToolBand>,
	public IDispatchImpl<IToolBand, &IID_IToolBand, &LIBID_tb4ieLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	///////////////
	// add by hand
		public IDeskBand,
		public IInputObject,
		public IPersistStream
	//
	///////////////
{
public:
	CToolBand();

DECLARE_REGISTRY_RESOURCEID(IDR_TOOLBAND)

BEGIN_COM_MAP(CToolBand)
	COM_INTERFACE_ENTRY(IToolBand)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	///////////////////////
	// add by hand
		COM_INTERFACE_ENTRY(IOleWindow)
		COM_INTERFACE_ENTRY_IID(IID_IDockingWindow, IDockingWindow)
		COM_INTERFACE_ENTRY_IID(IID_IDeskBand, IDeskBand)
		COM_INTERFACE_ENTRY(IPersist)
		COM_INTERFACE_ENTRY(IPersistStream)
		COM_INTERFACE_ENTRY_IID(IID_IInputObject, IInputObject)
	//
	///////////////
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	HRESULT FinalConstruct() { return S_OK;}
	void FinalRelease() {}

public:
//////////////////////////////////////////////////
// the rest of code add by hand

// IDeskBand
public:
	STDMETHOD(GetBandInfo)(DWORD dwBandID, DWORD dwViewMode, DESKBANDINFO* pdbi);

// IObjectWithSite
public:
	STDMETHOD(SetSite)(IUnknown* pUnkSite);
	STDMETHOD(GetSite)(REFIID riid, void **ppvSite);

// IOleWindow
public:
	STDMETHOD(GetWindow)(HWND* phwnd);
	STDMETHOD(ContextSensitiveHelp)(BOOL fEnterMode);

// IDockingWindow
public:
	STDMETHOD(CloseDW)(unsigned long dwReserved);
	STDMETHOD(ResizeBorderDW)(const RECT* prcBorder, IUnknown* punkToolbarSite, BOOL fReserved);
	STDMETHOD(ShowDW)(BOOL fShow);

// IPersist
public:
	STDMETHOD(GetClassID)(CLSID *pClassID);

// IPersistStream
public:
	STDMETHOD(IsDirty)(void);
	STDMETHOD(Load)(IStream *pStm);
	STDMETHOD(Save)(IStream *pStm, BOOL fClearDirty);
	STDMETHOD(GetSizeMax)(ULARGE_INTEGER *pcbSize);

// IInputObject methods
public:
	STDMETHOD (UIActivateIO) (BOOL, LPMSG);
	STDMETHOD (HasFocusIO) (void);
	STDMETHOD (TranslateAcceleratorIO) (LPMSG);

// IToolBand
public:
	void FocusChange(BOOL bFocus);
    CCustomToolbar*	GetToolBarCtrl() {return m_pToolbarCtrl;}

protected:
	BOOL RegisterAndCreateWindow();

// Data
protected:
	BOOL		m_bShow;
	BOOL		m_bEnterHelpMode;
	HWND		m_hWndRebar;
	DWORD		m_dwBandId;
	DWORD		m_dwViewMode;
	
    CReflectionWnd		m_reflectWnd;		// Used for reflecting messages
	CCustomToolbar*		m_pToolbarCtrl;		// pointer to our custom toolbar
    IWebBrowser2*		m_pWebBrowser;		// pointer to browser object
	IInputObjectSite*	m_pSite;
};

OBJECT_ENTRY_AUTO(__uuidof(CoToolBand), CToolBand)
